package jcademo.client;

import java.util.Properties;
import java.util.UUID;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageConsumer;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class ClientJMS {
	public static void main(String[] args) throws NamingException, JMSException {
		// connect to message queue
		Properties env = new Properties();
        env.put(Context.INITIAL_CONTEXT_FACTORY,"org.jboss.naming.remote.client.InitialContextFactory");
        env.put(Context.PROVIDER_URL, "http-remoting://localhost:8080");
        Context ctx = new InitialContext(env);
        ConnectionFactory cf = (ConnectionFactory)ctx.lookup("jms/RemoteConnectionFactory");
        Connection con = cf.createConnection("arne", "topsecret");
        con.start();
        Session ses = con.createSession(false, Session.AUTO_ACKNOWLEDGE);
        // send line with id and line with numbers to add to input queue
        Queue qsend = ses.createQueue("test2inqueue");
        MessageProducer sender = ses.createProducer(qsend);
        Message smsg = ses.createTextMessage(UUID.randomUUID().toString() + "\r\n123 456");
        sender.send(smsg);
        sender.close();
        // read and output all lines from output queue 
        Queue qrecv = ses.createQueue("test2outqueue");
        MessageConsumer receiver = ses.createConsumer(qrecv);
        TextMessage msg = (TextMessage)receiver.receive();
        System.out.println(msg.getText());
        // close
        ses.close();
        con.close();
	}
}
