package jcademo.ejb;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.EJB;
import javax.ejb.MessageDriven;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;

import jcademo.domain.ABC;
import jcademo.domain.Bundle;
import jcademo.domain.Callback;

// MDB Test1Service is called with messages from message queue test1queue
@MessageDriven(name="Test1Service",
               activationConfig={@ActivationConfigProperty(propertyName="destinationType", propertyValue="javax.jms.Queue"),
                                 @ActivationConfigProperty(propertyName="destination", propertyValue="java:jboss/exported/jms/queue/test1queue")})
public class Test1MDB implements MessageListener {
	@EJB
	private TestSLSB slsb;
	@Override
	public void onMessage(Message msg) {
		try {
			// explode bundle
			Bundle bundle = (Bundle)((ObjectMessage)msg).getObject();
			ABC o = bundle.getABC();
			Callback cb = bundle.getCallback();
			int a = o.getA();
			int b = o.getB();
			// apply business logic
			int c = slsb.add(a, b);
			// let callback handle response
			o.setC(c);
			cb.sendResponse(o);
		} catch (JMSException e) {
			e.printStackTrace();
		}
	}
}
