package jcademo.rainbound.multcp;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.net.Socket;

import javax.resource.spi.UnavailableException;
import javax.resource.spi.endpoint.MessageEndpointFactory;
import javax.resource.spi.work.Work;

public class MulTCPClientWorker implements Work {
	private MessageEndpointFactory mepf;
	private TestSpec as;
	private Socket s;
	public MulTCPClientWorker(MessageEndpointFactory mepf, TestSpec as, Socket s) {
		this.mepf = mepf;
		this.as = as;
		this.s = s;
	}
	@Override
	public void run() {
		try {
			if(as.isDebug()) {
				System.out.println("Client handler starting");
			}
			BufferedReader br = new BufferedReader(new InputStreamReader(s.getInputStream(), "UTF-8"));
			PrintStream ps = new PrintStream(s.getOutputStream(), false, "UTF-8");
			// process multiple requests on same socket
			while(true) {
				// read numbers to add
				String line = br.readLine();
				if(line == null) break;
				String[] lineparts = line.split(" ");
				int a = Integer.parseInt(lineparts[0]);
				int b = Integer.parseInt(lineparts[1]);
				// allocate, use and release MDB
				TestListener mep = (TestListener)mepf.createEndpoint(null);
				mep.setDebug(as.isDebug());
				int c = mep.add(a, b);
				mep.release();
				// write result
				ps.println(c);
			}
			// close
			ps.close();
			br.close();
			s.close();
			if(as.isDebug()) {
				System.out.println("Client handler done");
			}
		} catch (UnavailableException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	@Override
	public void release() {
	}
}
