package jcademo.rainbound.multcp;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

import javax.resource.ResourceException;
import javax.resource.spi.endpoint.MessageEndpointFactory;
import javax.resource.spi.work.Work;
import javax.resource.spi.work.WorkManager;

// accept connections and start new client handler for each connection
public class MulTCPWorker implements Work {
	private WorkManager wm;
	private MessageEndpointFactory mepf;
	private TestSpec as;
	private ServerSocket ss;
	private boolean done;
	public MulTCPWorker(WorkManager wm, MessageEndpointFactory mepf, TestSpec as, ServerSocket ss) throws ResourceException {
		this.wm = wm;
		this.mepf = mepf;
		this.as = as;
		this.ss = ss;
	}
	@Override
	public void run() {
		done = false;
		while(!done) {
			try {
				// accept connections and start new client handler for each connection
				Socket s = ss.accept();
				if(as.isDebug()) {
					System.out.println("Accepted connection starting client worker");
				}
				wm.scheduleWork(new MulTCPClientWorker(mepf, as, s));
			} catch (ResourceException e) {
				e.printStackTrace();
				done = true;
			} catch (IOException e) {
				e.printStackTrace();
				done = true;
			}
		}
	}
	@Override
	public void release() {
		done = true;
		try {
			ss.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
