package jcademo.rainbound.permtcp;

import java.io.PrintStream;

import javax.resource.spi.UnavailableException;
import javax.resource.spi.endpoint.MessageEndpointFactory;
import javax.resource.spi.work.Work;

public class PermTCPClientWorker implements Work {
	private MessageEndpointFactory mepf;
	private TestSpec as;
	private PrintStream ps;
	private String id;
	private int a;
	private int b;
	public PermTCPClientWorker(MessageEndpointFactory mepf, TestSpec as, PrintStream ps, String id, int a, int b) {
		this.mepf = mepf;
		this.as = as;
		this.ps = ps;
		this.id = id;
		this.a = a;
		this.b = b;
	}
	@Override
	public void run() {
		try {
			if(as.isDebug()) {
				System.out.println("Client handler starting");
			}
			// allocate, use and release MDB
			TestListener mep = (TestListener)mepf.createEndpoint(null);
			mep.setDebug(as.isDebug());
			int c = mep.add(a, b);
			mep.release();
			// write id and result
			synchronized(ps) {
				ps.println(id);
				ps.println(c);
				ps.flush();
			}
			//
			if(as.isDebug()) {
				System.out.println("Client handler done");
			}
		} catch (UnavailableException e) {
			e.printStackTrace();
		}
	}
	@Override
	public void release() {
	}
}
