package jcademo.rainbound.tcp;

import java.io.IOException;
import java.net.ServerSocket;

import javax.resource.ResourceException;
import javax.resource.spi.ActivationSpec;
import javax.resource.spi.BootstrapContext;
import javax.resource.spi.ResourceAdapter;
import javax.resource.spi.endpoint.MessageEndpointFactory;
import javax.resource.spi.work.Work;
import javax.resource.spi.work.WorkManager;
import javax.transaction.xa.XAResource;

//JCA Adapter
public class TCPAdapter implements ResourceAdapter {
	private Integer port;
	public Integer getPort() {
		return port;
	}
	public void setPort(Integer port) {
		this.port = port;
	}
	private WorkManager wm;
	private Work w;
	@Override
	public void start(BootstrapContext bctx) {
		wm = bctx.getWorkManager();
	}
	// when activated start listener thread
	@Override
	public void endpointActivation(MessageEndpointFactory mepf, ActivationSpec as) throws ResourceException {
		try {
			ServerSocket ss = new ServerSocket(port);
			w = new TCPWorker(wm, mepf, (TestSpec)as, ss);
			wm.scheduleWork(w);
		} catch (IOException e) {
			throw new ResourceException(e);
		}
	}
	@Override
	public void endpointDeactivation(MessageEndpointFactory mepf, ActivationSpec as) {
	}
	@Override
	public void stop() {
		w.release();
	}
	@Override
	public XAResource[] getXAResources(ActivationSpec[] as) throws ResourceException {
		throw new ResourceException("no XA support");
	}
	@Override
	public int hashCode() {
		return super.hashCode();
	}
	@Override
	public boolean equals(Object o) {
		return this == o;
	}
}
