package jcademo.rainbound.udp;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;

// utility class to send and receive a bundle of lines (id + numbers to add) + client address + client port
public class UDPUtil {
	public static class DataAndOrigin {
		private String data;
		private InetAddress address;
		private int port;
		public DataAndOrigin(String data, InetAddress address, int port) {
			this.data = data;
			this.address = address;
			this.port = port;
		}
		public String getData() {
			return data;
		}
		public InetAddress getAddress() {
			return address;
		}
		public int getPort() {
			return port;
		}
	}
	public static DataAndOrigin receive(DatagramSocket dgs) throws IOException {
		byte[] b = new byte[1000];
		DatagramPacket dp = new DatagramPacket(b, b.length);
		synchronized(dgs) {
			dgs.receive(dp);
		}
		return new DataAndOrigin(new String(dp.getData(), 0, dp.getLength(), "UTF-8"), dp.getAddress(), dp.getPort());
	}
	public static void send(DatagramSocket dgs, DataAndOrigin dao) throws IOException {
		byte[] b = dao.getData().getBytes("UTF-8");
		DatagramPacket dp = new DatagramPacket(b, b.length);
		dp.setAddress(dao.getAddress());
		dp.setPort(dao.getPort());
		synchronized(dgs) {
			dgs.send(dp);
		}
	}
}
