package jcademo.rainbound.udp;

import java.io.IOException;
import java.net.DatagramSocket;

import javax.resource.ResourceException;
import javax.resource.spi.endpoint.MessageEndpointFactory;
import javax.resource.spi.work.Work;
import javax.resource.spi.work.WorkManager;

// receive datagrams and start new client handler for each datagram
public class UDPWorker implements Work {
	private WorkManager wm;
	private MessageEndpointFactory mepf;
	private TestSpec as;
	private DatagramSocket dgs;
	private boolean done;
	public UDPWorker(WorkManager wm, MessageEndpointFactory mepf, TestSpec as, DatagramSocket dgs) throws ResourceException {
		this.wm = wm;
		this.mepf = mepf;
		this.as = as;
		this.dgs = dgs;
	}
	@Override
	public void run() {
		done = false;
		while(!done) {
			try {
				// receive datagrams and start new client handler for each datagram
				UDPUtil.DataAndOrigin dao = UDPUtil.receive(dgs);
				if(as.isDebug()) {
					System.out.println("Received packet starting client worker");
				}
				wm.scheduleWork(new UDPClientWorker(mepf, as, dgs, dao));
			} catch (ResourceException e) {
				e.printStackTrace();
				done = true;
			} catch (IOException e) {
				e.printStackTrace();
				done = true;
			}
		}
	}
	@Override
	public void release() {
		done = true;
		dgs.close();
	}
}
