package jcademo.web;

import java.io.BufferedReader;
import java.io.IOException;
import java.util.UUID;

import javax.annotation.Resource;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jcademo.domain.ABC;
import jcademo.domain.AsyncCallback;
import jcademo.domain.AsyncHelper;
import jcademo.domain.Bundle;
import jcademo.domain.Callback;

@WebServlet(urlPatterns={"/testasync"},asyncSupported=true)
public class TestServletAsync extends HttpServlet {
	private static final long serialVersionUID = 1L;
	private static AsyncHelper ah = AsyncHelper.getInstance();;
    @Resource(mappedName="java:/JmsXA")
    private ConnectionFactory cf;
    @Resource(mappedName="java:jboss/exported/jms/queue/test1queue")
    private Queue q;
	@Override
    public void doPost(HttpServletRequest req, HttpServletResponse resp) throws IOException {
		// read line with numbers
		String line = new BufferedReader(req.getReader()).readLine();
		// parse numbers
		String[] lineparts = line.split(" ");
		int a = Integer.parseInt(lineparts[0]);
		int b = Integer.parseInt(lineparts[1]);
		// setup async context
		ABC o = new ABC(a, b);
		String id = UUID.randomUUID().toString();
		ah.save(id, req.startAsync());
		Callback cb = new AsyncCallback(id);
		Bundle bundle = new Bundle(o, cb);
        try {
        	// send context to message queue test1queue
			Connection c = cf.createConnection();
			Session ses = c.createSession(false,  Session.AUTO_ACKNOWLEDGE);
			MessageProducer sender = ses.createProducer(q);
			sender.send(ses.createObjectMessage(bundle));
			c.close();
		} catch (JMSException e) {
			e.printStackTrace();
		}
	}
}
